#pragma once

#include <string>
#include <memory>
#include <vector>

class ClientAccess {
	ClientAccess();
	ClientAccess(const std::string& token, uint16_t port);
public:
	static std::shared_ptr<ClientAccess> find(bool uselockfile = true);
private:
	// returns the name and value of a argument or empty string if it could not be parsed
	static std::string parseArg(const std::string& input, std::string& value);
	static std::shared_ptr<ClientAccess> findUsingArgs(const std::vector<std::string>& cmdline);
	static std::shared_ptr<ClientAccess> findUsingLockfile(const std::vector<std::string>& cmdline, pid_t pid);

public:
	std::string getBasicAuth() const;
	uint16_t getPort() const;

	std::string getURL() const;

private:

	std::string authcode;
	uint16_t port = 0;
};