#pragma once

#include <string>
#include <QJsonDocument>
#include <curl/curl.h>

class RestClient {
public:
	RestClient(const std::string& base);
	virtual ~RestClient();

	enum class Method {
		GET,
		POST,
		PUT,
		PATCH,
		DELETE
	};

protected:
	QByteArray requestRaw(const std::string& url, Method m = Method::GET, const std::string& data = {});
	QJsonDocument request(const std::string& url, Method m = Method::GET, const std::string& data = {});
	void enableDebugging(bool enabled = true);

	std::string baseurl;

	CURL* curl = nullptr; // the curl (does curling)

	std::string basicauth; // basic auth code (user:pw) or empty string to disable
	bool disableCertCheck = false;
};
