#include "datadragonimagecache.h"

#include <QFile>
#include <QPixmap>

#include <Log.h>

#include "files.h"

DataDragonImageCache::DataDragonImageCache(const std::string& folderextra, const std::string& imageext) : imageext(imageext) {
	// init cache dir
	cacheDir = getHome() + ".cache/lolautoaccept/" + folderextra + "/";

	mkdirs(cacheDir);
}
DataDragonImageCache::~DataDragonImageCache() {}

QPixmap DataDragonImageCache::getImage(const std::string& name) {
	return QPixmap(QString::fromStdString(getFilepath(name)));
}

void DataDragonImageCache::addImageRaw(const QByteArray& arr, const std::string& name) {
	QFile file(QString::fromStdString(getFilepath(name)));
	file.open(QIODevice::WriteOnly);
	file.write(arr);
}

std::string DataDragonImageCache::getFilepath(const std::string& name) const {
	return cacheDir + name + imageext;
}
